﻿// -------------------------------------------------------
// Automatically generated with Kodeo's Reegenerator
// Generator: RgenTemplate (internal)
// Generation date: 2019-03-09 11:35
// Generated by: Christian-PC\Christian
//-------------------------------------------------------
namespace OneAccomplishment.CodeGen.Data.Essentials
{
    using OneAccomplishment.CodeGen.Renderers;
    
    
    [System.CodeDom.Compiler.GeneratedCodeAttribute("Reegenerator", "2.0.16.0")]
    [Kodeo.Reegenerator.Generators.TemplateDisplayAttribute(DisplayName=null, Description=null, HideInDialog=true)]
    public partial class PermissionEnumsRenderer : NestedCodeRenderer
    {
        
        /// <summary>
        ///Renders the code as defined in the source script file.
        ///</summary>
        ///<returns></returns>
        public override Kodeo.Reegenerator.Generators.RenderResults Render()
        {
            this.Output.Write("namespace ");
            this.Output.Write( PermissionsNamespace );
            this.Output.Write("\r\n{\r\n    public static partial class Permissions\r\n    {\r\n    ");
  foreach (var current in PermissionCategories) { 
            this.Output.Write("\r\n        public static class ");
            this.Output.Write( current.ValidCategory );
            this.Output.Write("\r\n        {\r\n        ");
  foreach (var permission in current.Permissions) { 
            this.Output.Write("\r\n            /// <summary>\r\n            /// ");
            this.Output.Write( current.Category );
            this.Output.Write(" Permission: ");
            this.Output.Write( permission.Name );
            this.Output.Write(" = ");
            this.Output.Write( permission.Value );
            this.Output.Write("\r\n            /// <para>Description: ");
            this.Output.Write( permission.Description );
            this.Output.Write("</para>\r\n            /// </summary>\r\n            public const long ");
            this.Output.Write( permission.ValidName );
            this.Output.Write(" = ");
            this.Output.Write( permission.Value );
            this.Output.Write(";\r\n        ");
  } 
            this.Output.Write("\r\n        }\r\n    ");
  } 
            this.Output.Write("\r\n    }\r\n}");
            this.Output.WriteLine();
            return new Kodeo.Reegenerator.Generators.RenderResults(this.Output.ToString());
        }
    }
}
